=== debian/changelog ===
nsis (3.05-2) unstable; urgency=medium

  [ Thomas Gaugler ]
  * d/control: Switch to secure (HTTPS) homepage
  * d/control: Set Rules-Requires-Root to no
  * Consistent use of flags in test and install targets
  * Remove build directory instead of clean up via Scons
  * Reduce build scope by skipping plugins and stubs for host tools
  * Removal of LibraryLocal man page
  * Propagate CCACHE_DIR and SOURCE_DATE_EPOCH environment variables to
    SCons build system for ccache and reproducible builds
  * Python 3 fixes
  * Split suffixes prepended with + or ~ from version
  * Remove __pycache__ directory during clean

  [ Didier Raboud ]
  * Add Salsa CI pipeline config
  * Bump Standards-Version to 4.5 without changes needed
  * Discard .pyc files after clean (Closes: #952269)

 -- Thomas Gaugler <thomas@dadie.net>  Tue, 31 Mar 2020 20:05:25 +0200

nsis (3.05-1) unstable; urgency=medium

  [ Thomas Gaugler ]
  * New 3.05 upstream release (Closes: #947572)
  * Retain SEH flag also for resulting installer
  * Adapted line offsets of patches for NSIS 3.05

  [ Didier Raboud ]
  * Refresh d/copyright by merging all contributors and dates, per license;
    add the missing wxWindows license
  * Update standards version to 4.4.1, no changes needed.

 -- Didier Raboud <odyx@debian.org>  Wed, 15 Jan 2020 09:42:48 +0100

nsis (3.04-2) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Keep Structured Exception Handling (SEH) flag
  * Add debian/upstream/metadata file
  * Test package in its installed state
  * d/copyright: Fix matching of paths containing a space
  * Replace extracting version from changelog with DEB_VERSION
  * d/changelog: Remove empty line at the end of the file
  * Missing signature of tarball: Overrule lintian warning
  * Makensisw, NSIS Menu, zip2exe: overrule lintian warnings
  * Fix unaligned memory accesses (Closes: #918376)
  * Propagate SOURCE_DATE_EPOCH environment variable

  [ Didier Raboud ]
  * Update standards version to 4.4.0, no changes needed.
  * Bump debhelper from old 11 to 12.

 -- Thomas Gaugler <thomas@dadie.net>  Fri, 23 Aug 2019 15:07:51 +0200
