=== debian/watch ===
version=3
https://sf.net/nsis/nsis-([\d.]*)-src.tar.bz2 debian uupdate
