## nsis 3.06.1

=== SConstruct ===
--- 
+++ 
@@ -64,20 +64,20 @@
 #######  Build Environment                                         ###
 ######################################################################
 
+import os
 path = ARGUMENTS.get('PATH', '')
 toolset = ARGUMENTS.get('TOOLSET', '')
-arch = ARGUMENTS.get('TARGET_ARCH', 'x86')
-
-if toolset and path:
-	defenv = Environment(TARGET_ARCH = arch, ENV = {'PATH' : path}, TOOLS = toolset.split(',') + ['zip'])
-else:
-	if path:
-		defenv = Environment(TARGET_ARCH = arch, ENV = {'PATH' : path})
-	if toolset:
-		defenv = Environment(TARGET_ARCH = arch, TOOLS = toolset.split(',') + ['zip'])
-if not toolset and not path:
-	defenv = Environment(TARGET_ARCH = arch)
-
+
+defenv = {
+	'TARGET_ARCH': ARGUMENTS.get('TARGET_ARCH', 'x86'),
+	'ENV': {}
+}
+
+if path: defenv['ENV']['PATH'] = path
+if toolset: defenv['TOOLS'] = toolset.split(',') + ['zip']
+
+if len(defenv['ENV']) == 0: del defenv['ENV']
+defenv = Environment(**defenv)
 Export('defenv')
 
 ######################################################################
@@ -85,12 +85,12 @@
 ######################################################################
 
 SConscript('SCons/utils.py')
+Import('GetOptionOrEnv')
 
 ######################################################################
 #######  Options                                                   ###
 ######################################################################
 
-import os
 default_doctype = 'html'
 if defenv.WhereIs('hhc', os.environ['PATH']):
 	default_doctype = 'chm'
@@ -195,6 +195,8 @@
 opts.Add(('PREFIX_DOC','Path to install nsis README / INSTALL / TODO files to.', dirs['doc']))
 opts.Add(('PREFIX_PLUGINAPI_INC','Path to install plugin API headers to.', None))
 opts.Add(('PREFIX_PLUGINAPI_LIB','Path to install plugin static library to.', None))
+# reproducible builds
+opts.Add(('SOURCE_DATE_EPOCH', 'UNIX timestamp (in seconds)', os.environ.get('SOURCE_DATE_EPOCH')))
 
 opts.Update(defenv)
 Help(opts.GenerateHelpText(defenv))
@@ -210,6 +212,10 @@
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_CONF', '"%s"' % defenv.subst('$PREFIX_CONF'))])
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DATA', '"%s"' % defenv.subst('$PREFIX_DATA'))])
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DOC', '"%s"' % defenv.subst('$PREFIX_DOC'))])
+
+if defenv.get('SOURCE_DATE_EPOCH','') is not '':
+	defenv['ENV']['SOURCE_DATE_EPOCH'] = defenv['SOURCE_DATE_EPOCH'] = int(defenv['SOURCE_DATE_EPOCH'], 0) # Normalize and apply to ENV for child processes
+	defenv.Append(NSIS_CPPDEFINES = [('NSIS_SOURCE_DATE_EPOCH', '%s' % defenv['SOURCE_DATE_EPOCH'])]) # Display in /HDRINFO
 
 # Need this early for the config header files to be placed in
 if defenv['UNICODE']:
@@ -278,12 +284,15 @@
 	Exit(1)
 f.write('#define NSIS_PACKEDVERSION _T("%s")\n' % defenv['VER_PACKED'])
 
-if 'VER_MAJOR' in defenv and defenv.get('VERSION','') == '':
+if defenv.get('VERSION','') == '' and 'VER_MAJOR' in defenv:
 	defenv['VERSION'] = defenv['VER_MAJOR']
 	if 'VER_MINOR' in defenv:
 		defenv['VERSION'] += '.' + defenv['VER_MINOR']
 	if 'VER_REVISION' in defenv:
 		defenv['VERSION'] += '.' + defenv['VER_REVISION']
+if defenv.get('VERSION','') == '' and int(defenv['VER_PACKED'], 0) > int('0x02000000', 0):
+	defenv['VERSION'] = '%i.%i.%i' % (int(defenv['VER_PACKED'][2:][:2]), int(defenv['VER_PACKED'][4:][:3]), int(defenv['VER_PACKED'][7:][:2]))
+	print('WARNING: VERSION not set, defaulting to %s!' % defenv['VERSION'])
 f.write('#define NSIS_VERSION _T("v%s")\n' % defenv['VERSION'])
 
 f.close()
@@ -292,29 +301,3 @@
 #######  Common Functions                                          ###
 ######################################################################
 
-def GetArcCPU(env):
-	if (not 'TARGET_ARCH' in env) or env['TARGET_ARCH'] == 'x86':
-		return 'x86'
-	return env['TARGET_ARCH']
-
-def GetArcSuffix(env, unicode = None):
-	if unicode is None:
-		unicode = 'UNICODE' in env['CPPDEFINES']
-	suff = '-unicode'
-	if not unicode:
-		suff = '-ansi'
-	return GetArcCPU(env) + suff
-
-def SafeFile(f):
-	from types import StringType
-
-	if isinstance(f, StringType):
-		return File(f)
-
-	return f
-
-def MakeFileList(files):
-	return Flatten(File(files))
-
-def AddEnvStandardFlags(env, defines=None, flags=None, libs=None, entry=None, nodeflib=None):
-	if defines:
