=== debian/changelog ===
nsis (3.06.1-1) unstable; urgency=medium

  * New upstream version 3.06.1
  * Adapted patches for version '3.06.1'
  * Python equality vs identity fix within scons scripts
  * Set CCACHE_DIR after initialization of default environment
  * Exclude POSIX incompatible install-(per-user|shared) test scripts
  * Increase to debhelper compatibility level 13
  * Plugin/nsis: override repeated-path-segment lintian warning
  * Mark SEH patch as not needed for upstream

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 29 Aug 2020 21:32:12 +0200

nsis (3.05-4) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Define halibut version string as external variable
    GCC 10 uses -fno-common by default and as a result the global version
    variable of halibut was considered to be defined multiple times.
    (Closes: #966870)

 -- Didier Raboud <odyx@debian.org>  Thu, 06 Aug 2020 17:33:42 +0200

nsis (3.05-3) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Skip blhc job in Salsa CI pipeline

  [ Didier Raboud ]
  * Backport 'Don't let GCC 10 generate memmove calls (bug #1248)'
    upstream patch (Closes: #963282)

 -- Didier Raboud <odyx@debian.org>  Fri, 03 Jul 2020 16:06:02 +0200
