=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                scons,
                xsltproc,
                zlib1g-dev,
-               debhelper-compat (= 12)
+               debhelper-compat (= 13)
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/nsis
