=== debian/rules ===
--- 
+++ 
@@ -110,7 +110,7 @@
   SKIPUTILS=$(IGNORE_UTILS_COMMON) SKIPDOC=COPYING
 
 # Exclude test scripts which are not appropriate for POSIX platforms.
-IGNORE_TESTS = makensis.nsi|gfx.nsi
+IGNORE_TESTS = gfx.nsi|install-per-user.nsi|install-shared.nsi|makensis.nsi
 
 # Path to .nsi scripts
 SCRIPTS_PATH = $(DOCDIR)/Examples
@@ -219,4 +219,3 @@
 		fi;; \
 		esac; \
 	done;
-	# Fail the build if libwinpthread is needed at runtime (see #722898)
