=== debian/tests/control ===
Test-Command: cp "/usr/share/doc/nsis/Examples/Modern UI/MultiLanguage.nsi" . && makensis MultiLanguage.nsi
Depends: nsis, nsis-doc
Tests-Directory: tests
