## nsis 3.08

=== SConstruct ===
--- 
+++ 
@@ -57,7 +57,8 @@
 doctypes = [
 	'chm',
 	'html',
-	'htmlsingle'
+	'htmlsingle',
+	'web',
 ]
 
 ######################################################################
@@ -95,8 +96,8 @@
 if defenv.WhereIs('hhc', os.environ['PATH']):
 	default_doctype = 'chm'
 
-from time import strftime, gmtime
-cvs_version = strftime('%d-%b-%Y.cvs', gmtime())
+import time
+cvs_version = time.strftime('%d-%b-%Y.cvs', time.gmtime(int(os.environ.get('SOURCE_DATE_EPOCH', time.time()))))
 
 opts = Variables()
 
@@ -213,7 +214,7 @@
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DATA', '"%s"' % defenv.subst('$PREFIX_DATA'))])
 	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DOC', '"%s"' % defenv.subst('$PREFIX_DOC'))])
 
-if defenv.get('SOURCE_DATE_EPOCH','') is not '':
+if defenv.get('SOURCE_DATE_EPOCH','') != '':
 	defenv['ENV']['SOURCE_DATE_EPOCH'] = defenv['SOURCE_DATE_EPOCH'] = int(defenv['SOURCE_DATE_EPOCH'], 0) # Normalize and apply to ENV for child processes
 	defenv.Append(NSIS_CPPDEFINES = [('NSIS_SOURCE_DATE_EPOCH', '%s' % defenv['SOURCE_DATE_EPOCH'])]) # Display in /HDRINFO
 
@@ -299,5 +300,3 @@
 
 ######################################################################
 #######  Common Functions                                          ###
-######################################################################
-
