=== debian/changelog ===
nsis (3.08-2) unstable; urgency=medium

  * autopkgtest: Verify generated NSIS installer executable
  * d/copyright: Merged contributors, updated years, added
    bzip2 and lzma SDK license

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 04 Dec 2021 10:14:19 +0100

nsis (3.08-1) unstable; urgency=medium

  * New upstream version 3.08
  * Fix fprintf format security warnings for halibut
  * debian/watch: Upgrade to version 4

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 01 Nov 2021 11:04:27 +0800

nsis (3.07-1) unstable; urgency=medium

  * New upstream version 3.07

  [ Thomas Gaugler ]
  * Drop obsolete patches for version '3.07'
  * Propagate CCACHE_DIR environment variable via debian/rules
  * Use common tool variables inside debian/rules
  * Upgrade to Standards-Version 4.6.0 without changes needed
  * Remove outdated claim of overhead size within debian/control

  [ Didier Raboud ]
  * Remove myself from Uploaders

 -- Thomas Gaugler <thomas@dadie.net>  Wed, 01 Sep 2021 15:26:05 +0200
