=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: nsis
 Maintainer: Thomas Gaugler <thomas@dadie.net>
-Uploaders: Didier Raboud <odyx@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: docbook-xsl-ns,
@@ -13,7 +12,7 @@
                xsltproc,
                zlib1g-dev,
                debhelper-compat (= 13)
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/nsis
 Vcs-Git: https://salsa.debian.org/debian/nsis.git
@@ -38,8 +37,7 @@
  script language supports variables, functions, string manipulation,
  just like a normal programming language - but designed for the creation
  of installers. Even with all these features, NSIS is still the smallest
- installer system available. With the default options, it has an overhead
- of only 34 KB.
+ installer system available.
 
 Package: nsis-common
 Architecture: all
