=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 include /usr/share/dpkg/pkg-info.mk
+include /usr/share/dpkg/buildtools.mk
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -49,6 +50,11 @@
 SCONSHOSTFLAGS = APPEND_CCFLAGS="$(shell dpkg-buildflags --get CPPFLAGS) \
   $(shell dpkg-buildflags --get CFLAGS)" \
   APPEND_LINKFLAGS="$(shell dpkg-buildflags --get LDFLAGS)"
+
+# Propagate CCACHE_DIR environment variable
+ifneq (,$(CCACHE_DIR))
+	SCONSHOSTFLAGS += CC="CCACHE_DIR=\"$(CCACHE_DIR)\" $(CC)" CXX="CCACHE_DIR=\"$(CCACHE_DIR)\" $(CXX)"
+endif
 
 SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) VER_MAJOR=$(VER_MAJOR) \
   VER_MINOR=$(VER_MINOR) VER_REVISION=$(VER_REVISION) \
@@ -211,11 +217,3 @@
 		if [ -f "$${script_path}" ]; then \
 			PATH=$(TESTDIR)$(PREFIX)/bin:$(PATH) \
 			NSISDIR=$(TESTDIR)$(DATADIR) \
-			NSISCONFDIR=$(TESTDIR)$(SYSCONF) \
-			"$(TESTDIR)$(PREFIX)/bin/makensis" \
-			"$${script_path}" \
-			-X"OutFile \"$(TESTDIR)/$${script%.nsi}.exe\"" \
-			|| exit 1; \
-		fi;; \
-		esac; \
-	done;
