=== debian/tests/control ===
Test-Command: cp "/usr/share/doc/nsis/Examples/Modern UI/MultiLanguage.nsi" . && makensis MultiLanguage.nsi && 7z t -tNsis MultiLanguage.exe
Depends: nsis, nsis-doc, p7zip-full
Tests-Directory: tests
