## nsis 3.09

=== debian/changelog ===
nsis (3.09-4ubuntu1) noble; urgency=medium

  * d/rules: strip off ubuntuX, buildX from package version before feeding it
    to scons as VERSION.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 11 Apr 2024 14:22:37 +1200

nsis (3.09-4build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:02:28 +1100

nsis (3.09-4) unstable; urgency=medium

  * Use -rcfile instead of -style command line option for html2text
    (Closes: #1064741)

 -- Thomas Gaugler <thomas@dadie.net>  Sat, 02 Mar 2024 09:11:24 +0100

nsis (3.09-3) unstable; urgency=medium

  * Use common options for nsis-doc installation
  * Added Breaks+Replaces fields to facilitate move of plugin example
    (Closes: #1060310)
  * Remove the disable reloc flag that is set by SCons
  * Exclude Debian revison suffix from VER_REVISION

 -- Thomas Gaugler <thomas@dadie.net>  Sun, 28 Jan 2024 11:58:35 +0100

nsis (3.09-2) unstable; urgency=medium

  * Bump Standards-Version to 4.6.2 (no changes needed)
  * Remove outdated debian/NEWS file
  * Eliminate leading comma in SKIPUTILS parameter
  * d/rules: Remove extraneous spaces
  * Use INSTDIR variable for common install path
  * Move plugin example from nsis-doc to nsis-pluginapi

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 08 Jan 2024 11:14:55 +0100

nsis (3.09-1) unstable; urgency=medium

  * New upstream version 3.09. Fixes CVE-2023-37378. Closes: #1040880
  * Drop obsolete halibut patch for version '3.09'

 -- Thomas Gaugler <thomas@dadie.net>  Thu, 20 Jul 2023 09:58:41 +0200

nsis (3.08-3) unstable; urgency=medium

  [ Thomas Gaugler ]
  * Disable relocations for PE/COFF binary files
    - NSIS does not handle relocations.
    - See https://sourceforge.net/p/nsis/bugs/1283/ for more details
  * Fixes lintian:
    - no-code-sections falsely reported on PE/COFF libraries, #1005326
    - Overwrite very-long-line-length-in-source-file tag for ini,
      but (input format for generating documentiation) and HTML files
    - Overwrite source-is-missing tag because the HTML files are the
      original source files
    - Correct mismatched and unused overrides
  * Update standards version to 4.6.1

  [ Janitor ]
  * Remove unnecessary dpkg-dev constraint

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 15 Aug 2022 07:58:35 +0200
