=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: nsis
-Maintainer: Thomas Gaugler <thomas@dadie.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Thomas Gaugler <thomas@dadie.net>
 Section: devel
 Priority: optional
 Build-Depends: docbook-xsl-ns,
                docbook5-xml,
-               dpkg-dev (>= 1.17.0),
-               html2text,
+               html2text (>= 2.0.0),
                libcppunit-dev,
                mingw-w64,
                scons,
                xsltproc,
                zlib1g-dev,
                debhelper-compat (= 13)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/nsis
 Vcs-Git: https://salsa.debian.org/debian/nsis.git
@@ -54,6 +54,9 @@
 Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: mingw-w64
+Replaces: nsis-doc (<< 3.09-2)
+Breaks: nsis-doc (<< 3.09-2)
+Suggests: nsis-doc (>= 3.09-2)
 Enhances: nsis (>= ${source:Version})
 Description: Nullsoft Scriptable Install System plugin API
  NSIS is a tool for creating quick and user friendly installers for
