=== debian/rules ===
--- 
+++ 
@@ -11,13 +11,15 @@
 # Enable hardening
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
-VERSION=$(DEB_VERSION)
+VERSION=$(shell echo $(DEB_VERSION) | sed -Ee s/\(build\|ubuntu\)[0-9]+//)
+
 PREFIX=/usr
 DATADIR=$(PREFIX)/share/nsis
 DOCDIR=$(PREFIX)/share/doc/nsis
 SYSCONF=/etc
 BUILDDIR=build
 UNICODE=yes
+INSTDIR=$(CURDIR)/debian
 TESTDIR=$(CURDIR)/$(BUILDDIR)/test
 
 # Decomposition of version string
@@ -27,7 +29,7 @@
 VERSION_DECOMPOSED=$(call SPLIT,$(VERSION),. - + ~)
 VER_MAJOR=$(firstword $(VERSION_DECOMPOSED))
 VER_MINOR=$(word 2,$(VERSION_DECOMPOSED))
-VER_REVISION=$(word 3,$(VERSION_DECOMPOSED))
+VER_REVISION=$(firstword $(subst +, ,$(word 3,$(VERSION_DECOMPOSED))))
 
 # Variables for Win32/Win64 cross compiler
 XGCC_W32_X86 = i686-w64-mingw32-gcc
@@ -96,7 +98,7 @@
 IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(UTILS_ALL))
 
 # Build the win32 user interfaces (UIs) and RegTool
-IGNORE_UTILS_COMMON := $(subst Library/RegTool,,$(UTILS_ALL))
+IGNORE_UTILS_COMMON := $(subst Library/RegTool$(COMMA),,$(UTILS_ALL))
 IGNORE_UTILS_COMMON := $(subst $(COMMA)UIs,,$(IGNORE_UTILS_COMMON))
 
 SCONSOPTS_HOST   := $(SCONSHOSTFLAGS) $(SCONSOPTS) \
@@ -112,8 +114,9 @@
 INSTALL_nsis-pluginapi = install-pluginapi
 INSTALL_FLAGS_nsis-pluginapi = $(SCONSOPTS_COMMON)
 INSTALL_nsis-doc = install-examples install-doc install-docs
-INSTALL_FLAGS_nsis-doc = $(SCONSHOSTFLAGS) $(SCONSOPTS) \
-  SKIPUTILS=$(IGNORE_UTILS_COMMON) SKIPDOC=COPYING
+INSTALL_FLAGS_nsis-doc = $(SCONSOPTS_COMMON) \
+  SKIPPLUGINS=ExDLL SKIPSTUBS=all SKIPUTILS=$(IGNORE_UTILS_COMMON) \
+  SKIPDOC=COPYING
 
 # Exclude test scripts which are not appropriate for POSIX platforms.
 IGNORE_TESTS = gfx.nsi|install-per-user.nsi|install-shared.nsi|makensis.nsi
@@ -121,8 +124,29 @@
 # Path to .nsi scripts
 SCRIPTS_PATH = $(DOCDIR)/Examples
 
+# Add contents to the given Debian package by taking
+# INSTALL_FLAGS_<package> and INSTALL_<package> variables into account.
+# $(1) package name, for example nsis-common
+# $(2) additional flags for scons
 define DO_SCONS_INSTALL
-	scons $(INSTALL_FLAGS_$(1)) $(2) PREFIX_DEST="$(CURDIR)/debian/$(1)" $(INSTALL_$(1)) || exit 1;
+	scons $(INSTALL_FLAGS_$(1)) $(2) PREFIX_DEST="$(INSTDIR)/$(1)" $(INSTALL_$(1)) || exit 1;
+endef
+
+# Add contents to the given Debian package via the path specfic target
+# $(1) package name, for example nsis-common
+# $(2) path specfic scons target
+define DO_SCONS_INSTALL_EXTRA
+	scons $(INSTALL_FLAGS_$(1)) PREFIX_DEST="$(INSTDIR)/$(1)" "$(INSTDIR)/$(1)$(2)" || exit 1;
+endef
+
+# Convert html to text using the pretty.style configuration
+# $(1) html formatted input file
+# $(2) If omitted then the resulting text is written to standard output
+#      otherwise to the provided output file
+define HTML2TEXT_PRETTY
+	html2text -nobs \
+		-rcfile /usr/share/doc/html2text/examples/pretty.style \
+		$(if $(2),-o $(2) ,)$(1)
 endef
 
 # Substitute reference to License text file in Modern UI examples
@@ -173,7 +197,7 @@
 override_dh_auto_build-indep: $(BUILDDIR)/NEWS
 	# nsis-common must be built on little-endian
 	[ "$(shell dpkg-architecture -qDEB_BUILD_ARCH_ENDIAN)" = "little" ]
-	
+
 	scons $(SCONSOPTS_HOST) makensis
 ifdef XGCC_W32_X86_PATH
 	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_X86) stubs plugins utils
@@ -181,12 +205,12 @@
 ifdef XGCC_W32_AMD64_PATH
 	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_AMD64) stubs plugins utils
 endif
-	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI" "Contrib/Modern UI/Readme.html"
-	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI 2" "Contrib/Modern UI 2/Readme.html"
-	html2text -style pretty -nobs -o $(BUILDDIR)/README.VPatch Contrib/VPatch/Readme.html
-	html2text -style pretty -nobs -o $(BUILDDIR)/README.InstallOptions Contrib/InstallOptions/Readme.html
-	html2text -style pretty -nobs -o $(BUILDDIR)/README.MultiUser Contrib/MultiUser/Readme.html
-	html2text -style pretty -nobs -o $(BUILDDIR)/README.nsDialogs Contrib/nsDialogs/Readme.html
+	$(call HTML2TEXT_PRETTY,"Contrib/Modern UI/Readme.html","$(BUILDDIR)/README.Modern UI")
+	$(call HTML2TEXT_PRETTY,"Contrib/Modern UI 2/Readme.html","$(BUILDDIR)/README.Modern UI 2")
+	$(call HTML2TEXT_PRETTY,Contrib/VPatch/Readme.html,$(BUILDDIR)/README.VPatch)
+	$(call HTML2TEXT_PRETTY,Contrib/InstallOptions/Readme.html,$(BUILDDIR)/README.InstallOptions)
+	$(call HTML2TEXT_PRETTY,Contrib/MultiUser/Readme.html,$(BUILDDIR)/README.MultiUser)
+	$(call HTML2TEXT_PRETTY,Contrib/nsDialogs/Readme.html,$(BUILDDIR)/README.nsDialogs)
 
 override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
@@ -196,24 +220,3 @@
 override_dh_auto_test-indep:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	test -x "$(BUILDDIR)/$(BUILDTYPE)/makensis/makensis" && \
-	scons $(INSTALL_FLAGS_nsis) PREFIX_DEST="$(TESTDIR)"\
-		install-compiler install-conf && \
-	scons $(INSTALL_FLAGS_nsis-doc) PREFIX_DEST="$(TESTDIR)"\
-		install-examples && \
-	scons $(INSTALL_FLAGS_nsis-common) $(SCONSOPTS_X86) PREFIX_DEST="$(TESTDIR)" \
-		$(INSTALL_nsis-common) && \
-	scons $(INSTALL_FLAGS_nsis-common) $(SCONSOPTS_AMD64) PREFIX_DEST="$(TESTDIR)" \
-		$(INSTALL_nsis-common) && \
-	$(call SANITIZE_MODERN_UI,$(TESTDIR)$(DOCDIR)/Examples/Modern UI) && \
-	for script_path in $(TESTDIR)$(SCRIPTS_PATH)/*.nsi \
-		$(TESTDIR)$(SCRIPTS_PATH)/*/*.nsi; do \
-		script=$${script_path#$(TESTDIR)$(SCRIPTS_PATH)/}; \
-		if [ "$${script%/*}" != "$${script}" ]; then \
-			mkdir -p "$(TESTDIR)/$${script%/*}"; \
-		fi; \
-		case $${script} in \
-		$(IGNORE_TESTS)) ;; \
-		*) \
-		if [ -f "$${script_path}" ]; then \
-			PATH=$(TESTDIR)$(PREFIX)/bin:$(PATH) \
-			NSISDIR=$(TESTDIR)$(DATADIR) \
