=== debian/watch ===
version=4
https://sf.net/nsis/nsis-([\d.]*)-src.tar.bz2 debian uupdate
